#include "format_ppm.hh"
#include "commentaires_pnm.hh"

static int format_ppm(-1);

ppm_format::ppm_format():format(format_ppm)
{
}

ppm_format::ppm_format(int nothing):format(this)
{    
  format_ppm=tab_format.size()-1;
}



bool ppm_format::is_format(const char* name)
{
  ifstream id(name);
  
  if (!id)
    return false;
  if(id.get() != 'P')
    return false;
  if (id.get() != '6')
    return false;
  id.close();
  return true;
}
int ppm_format::load(const char* name,
		     int & dim,
		     int &width,
		     int& height,
		     unsigned char* & begin)
{
  int Width,Height;
  ifstream  id(name);
  int    val_max;
  size_t taille_comp_RGB = sizeof(unsigned char);
  int size;


  if(!id)
    return (-1);
  
  id.get();
  id.get();

  lire_commentaires(id);
  
  id >> Width;
  id >> Height;
  id >> val_max;
  id.get();  
  if(Width <=0 || Height <= 0 || val_max <1)
    {
      cerr << " Image non lue :  Contient des valeurs aberrantes" << endl;
      return(-2);
    }
  dim=3;
  width=Width;
  height=Height;
  size  = dim*width*height;
  begin = new unsigned char[size];
  id.read((char*)begin,taille_comp_RGB*size);
  id.close();
  return 0;
}
ostream& ppm_format::to_stream(ostream& s,
			       int  dim,
			       int width,
			       int height,
			       unsigned char*  begin)
{
  size_t taille_ind = sizeof(unsigned char);
  char date_format[256];
  time_t temps = time(NULL);
  struct tm *temps_local = localtime(&temps);
  int var_max = 255;
  
  strftime(date_format,sizeof date_format, "%x %X", temps_local);
  
  s << "P6" << endl;
  s << "# Derniere  sauvegarde: " <<date_format << endl;
  s << width << " " << height<< endl;
  s << var_max << endl;
  
  s.write((char*)begin,(int)(taille_ind*width*height*dim));
  
  return s;
}
int  ppm_format::save(const char* name,
		      int  dim,
		      int width,
		      int height,
		      unsigned char*  begin)
{
  ofstream f(name);
  
  if (!f)
    return -1;
  
  to_stream(f,dim,width,height,begin);
  f.close();
  return 0;
}
