
/** \file dynamic_kernel.hh
    \brief simpilication of the partition according to edge dynamic
     */
#ifndef __DYNAMIC_KERNEL__
#define __DYNAMIC_KERNEL__

#include "kernel.hh"
#include "water_value.hh"
#include <image.hh>

class dynamic_kernel : public kernel
{
private:
  water_value* data;
  int dynamic;
  image debug;
  image gradient;
  int max_level;
  int level;
public:
  dynamic_kernel(water_value&,image&,image&,int);
  virtual ~dynamic_kernel()
  {}
  void compute_kernel(combi_map_priv &map);
  bool continue_computation();
  void debug_output_image(combi_map_priv,water_value);
};

#endif
