#include "equivalent_cleaning.hh"

#define MIN(a,b) ((a)<(b)?(a):(b))
#define MAX(a,b) ((a)<(b)?(b):(a))


bool equivalent_cleaning::lambda(int level,vertex v1,vertex v2,dart b1,dart b2)
{
  vertex_data_color *V_data = ((vertex_data_color *)v_data);
  int s1, s2;

  s1=(*V_data)(v1).give_cardinal();
  s2=(*V_data)(v2).give_cardinal();
  s1=MIN(s1,s2);

  return (s1<size_threshold);
}
double equivalent_cleaning::value(vertex v)
{
  return 1/(*((vertex_data_color *)v_data))(v).give_cardinal();
}
double equivalent_cleaning::interest(int level,vertex v1,vertex v2,dart b,dart m_b)
{
  border_data_deriche *B_data = ((border_data_deriche *)b_data);
  vertex_data_color *V_data = ((vertex_data_color *)v_data);
  int p1, p2, front;
  double g, d1, d2, k;
  double g_max=B_data->give_max_gradient();

  g =(*B_data)(b).give_gradient();
  front = (*B_data)(b).give_cardinal();
  k =g_max*front;
  d1=g/k;
  g =(*B_data)(m_b).give_gradient();
  d2=g/k;
  d1=MAX(d1,d2);

  p1=(*V_data)(v1).give_perimetre();
  p2=(*V_data)(v2).give_perimetre();
  d2=(double)MIN(p1, p2)/(8.0*front);

  return d1*d2;
}
