/** \file equivalent_union_find.hh
    \brief File used to determine if two vertices are equivalent */

#ifndef __EQUIVALENT_UNION_FIND_HH__
#define __EQUIVALENT_UNION_FIND_HH__

#include "equivalent.hh"

/** Model class used to determine if two vertices are equivalent */
class equivalent_union_find: public equivalent
{
protected:
  // Pointor on the vertex dataset
  const vertex_data *v_data;
public:
  /// Constructor
  equivalent_union_find(const vertex_data &v):v_data(&v)
  {}
  /// Virtual destructor
  virtual ~equivalent_union_find()
  {}
  /// Pure virtual function to know if the two vertices must be merged
  virtual bool lambda(int,vertex,vertex,dart,dart)=0;
};

#endif // __EQUIVALENT_UNION_FIND_HH__
