#include "kernel_union_find.hh"

void kernel_union_find::compute_kernel(combi_map_priv & c_map)
{
  dart b, sig, msig;
  vertex v, v_msig, f_v, f_v_msig;

  // Initialization of the father and marked dart array
  contracted.reinit();
  list_label::iterator iter=c_map.vertex_set.first();
  while(iter<c_map.vertex_set.end())
  {
    Father[*iter]=*iter;
    iter++;
  }

  // Computation of the kernel
  iter=c_map.vertex_set.first();
  while(iter<c_map.vertex_set.end())
  {
    v=*(iter++);
    if (v==(long)c_map.give_background())
      continue;

    sig=b=c_map.m_1(v);
    f_v = find_compress(v);
    do
    {
      sig = c_map.sigma(sig);
      if (contracted(sig))
        continue;
      msig = c_map.alpha(sig);
      v_msig = c_map.m(msig);
      if (v_msig==(long)c_map.give_background())
        continue;
      f_v_msig = find_compress(v_msig);
      if (f_v_msig == f_v)
        continue;
      if ( !equiv->lambda(level,v,v_msig,sig,msig) )
        continue;
      nb_contracted++;
      contracted.light(msig);
      Father[f_v_msig] = f_v;
    }
    while( sig!=b );
  }
}
bool kernel_union_find::continue_computation()
{
  return false;
}
