#ifndef __WATER_BORDER_DATA_HH__
#define __WATER_BORDER_DATA_HH__

#include "value_set.hh"
#include "border_data.hh"
#include "water_vertex_data.hh"
#include <tab_sym_ptr.hh>
#include "combinatorial_map.hh"

class null_data_field
{
public:
  null_data_field()
  {}
  null_data_field(const char*messg ,const char* file,int line)
  {
    cerr << messg<< "File : "<<file<<", Line : "<<line<<endl;
  }
};

class water_borders : public border_data
{
public:

  water_borders(water_vertex_data *data,image &img):mode(cmp_watershed),v_data(data),img_gradient(&img)
  {}
  virtual ~water_borders()
  {}
  class dart_data
  {
  private:
    short pass_value;
    short dynamic;
    int cardinal; 
    unsigned char min;
    unsigned char max;
  public:
    friend class water_borders;
    dart_data(int);
    ~dart_data();    
    void alloc_histogram();
    void add(unsigned char  val,int freq=1);
    void merge(dart_data*);
  };
  void set_combinatorial_map(combi_map_priv*);
  
  virtual void init(combi_map_base &,dart) {}  
  /// Function to manage the border_value during the concatenation of
  /// a border
  void unallocate(dart);
  void contract_edge(combi_map_priv&,vertex,dart);
  void set_mode(reduction_mode m)
  {
    mode=m;
  }
  void update_vertex_owner(dart,vertex,vertex);
  void free_histograms(dart);
  void set_mean(dart);
  void merge(int,dart,dart,dart);
  void set_dynamic(dart,int) throw (null_data_field);
  int pass_value(dart);
  int dynamic(dart);
  int min(dart);
private:
  reduction_mode mode;
  combi_map_priv * map;
  water_vertex_data* v_data;
  tab_sym_ptr data_border;
  image * img_gradient;
  
  int value_lignel(dart);
  void merge_dynamics(int,dart,dart,dart);
  void compute_pass_values(int,dart,dart,dart);
  void update_pass_values(int,dart,dart,dart);
  int median(dart,dart_data*);
  int lignel_grad(segment_iterator&,image::iterator&);
  int min_with_max_volume(dart);
};
#endif
