#ifndef __WATER_VALUE_HH__
#define __WATER_VALUE_HH__

#include "pyramid.hh"
#include "value_set.hh"
#include "water_vertex_data.hh"
#include "water_border_data.hh"
#include "combinatorial_map.hh"




class water_value : public value_set
{
private:
  //pointer to the vertice data.
  reduction_mode mode;
  water_vertex_data *v_data;
  water_borders  b_data;
  tab_label *watershed;
  int wshed_flag;
  vertex find_compress(tab_label &,vertex);
public:

  water_value(water_vertex_data& v,image& grad):mode(cmp_watershed),v_data(&v),b_data(&v,grad)
  {}
  virtual ~water_value()
  {}
  /// Function to initialize the data_set during the construction of the pyramid
  void init(combi_map_base &);
  void set_combinatorial_map(combi_map_priv &c_map)
  {
    map = &c_map;
    b_data.set_combinatorial_map(map);
  }
  void set_mode(reduction_mode m)
  {
    mode=m;
    b_data.set_mode(m);
  }
  int depth(vertex v)
  {
    return v_data->give_depth(v);
  }
  void set_vertex_depth(vertex, int);
  /// Function to manage the data when an empty self-loop is  removed
  void remove_empty_self_loops(dart, dart, vertex);
  /// Function to manage the data when a double edge is removed
  void remove_double_edges(int, dart, dart,dart);
  
  /// Function to manage the data when vertex set is updated
  void update_vertex_set(int, vertex, vertex);
  void update_vertex_owner(dart d,vertex old,vertex father)
  {
    b_data.update_vertex_owner(d,old,father);
  }
  // pass the labels of initial vertices to value class.
  void set_labels(tab_label&,int);
  void set_mean(pyramid &);
  void compute_dynamics(int &);
  int dynamic(dart);
  int pass_value(dart);
  int min(dart d)
  {
    return b_data.min(d);
  }
};

#endif /* water_value.hh */
