
/** \file watershed.hh
    \brief computation of the watershed algorithm on a combinatorial
    map */
#ifndef __WATERSHED_HH__
#define __WATERSHED_HH__

#include "kernel.hh"
#include "water_value.hh"
#include <fifo_label.hh>
#define MASK -2
#define WSHED 0
#define INIT -1


class rm_watersheds;

class watershed : public kernel
{
protected:

  /// depths of the different initial vertices.
  water_value* data;
  /// boolean to indicate if a vertex already belongs to a bassin
  tab_label im0,imd;
  fifo_label watershed_set;
public:

  friend class rm_watersheds;
  /// constructor
  watershed(water_value&);

  virtual ~watershed();

  void compute_kernel(combi_map_priv &);
  bool continue_computation()
  {
    return false;
  }
};
#endif
